// Created with MonoDevelop
//
//    QuickStep: Acquire, view and identify spectra 
//    Copyright (C) 2022, Hiperscan GmbH Dresden, Germany
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.


using System;

namespace Hiperscan.GtkExtensions.Widgets
{
    public class OutLinedCombobox : OutLinedWidget
    {
        public OutLinedCombobox(Gtk.ComboBox combobox) : base(combobox)
        {
            this.GtkCombox.Changed += (sender, e) => this.CallValueChangedEvent();
        }

        public void SetComboBoxIterator(Gtk.ListStore list, 
                                        string activ_value)
        {
            try
            {
                Gtk.TreeIter iterator = new Gtk.TreeIter();
                Gtk.CellRendererText renderer = new Gtk.CellRendererText();

                this.GtkCombox.Clear();
                this.GtkCombox.Model = list;
                this.GtkCombox.PackStart(renderer, false);
                this.GtkCombox.AddAttribute(renderer, "text", 0);
                list.GetIterFirst(out iterator);
                string value = (string)list.GetValue(iterator, 0);
                foreach (var item in list)
                {
                    if (value == activ_value)
                    {
                        this.GtkCombox.SetActiveIter(iterator);
                        return;
                    }
                    list.IterNext(ref iterator);
                    value = (string)list.GetValue(iterator, 0);
                }
            }
            catch (Exception)
            {
                throw;
            }
        }

        protected override bool WidgetIsFocused
        {
            get
            {
                return false;
            }
        }

        public Gtk.ComboBox GtkCombox
        {
            get
            {
                return this.Widget as Gtk.ComboBox;
            }
        }
    }
}
